SystemOrganization addCategory: #RPSS!

WAComponent subclass: #RPSS_Administrator
	instanceVariableNames: 'email password initialized modified waiting url tempEmail tempPassword url2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_Administrator class
	instanceVariableNames: 'uniqueInstance'!

RPSS_Administrator class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_Administrator class methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:11'!
reset
	uniqueInstance := nil.! !

!RPSS_Administrator class methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:11'!
uniqueInstance 
	uniqueInstance ifNil: [uniqueInstance := self new].
	^uniqueInstance! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:38'!
activateWaiting
	waiting := true.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 20:22'!
confirmEmail
	email := tempEmail.
	tempEmail := ''.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:51'!
confirmFirstEmail
	waiting := false.
	initialized := true.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 20:10'!
confirmPassword
	password := tempPassword.
	tempPassword := ''.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:28'!
email
	^email.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:28'!
email: anEmail
	email := anEmail.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:23'!
initialize
	super initialize.
	email := ''.
	password := ''.
	initialized := false.
	waiting := false.
	url := ''.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:23'!
isInitialized
	^initialized.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:23'!
isWaiting
	^waiting.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 20:18'!
modifyEmail
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: tempEmail.
	from := MIMEHeaderValue forField: 'from' fromString: 'admin@ulb.ac.be'.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Password confirmation'.
	
	link := 'http://localhost:8080', url greaseString.
	bodyhtml := 'You can confirm your new email via this link: ', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 20:18'!
modifyPassword 
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: self email.
	from := MIMEHeaderValue forField: 'from' fromString: 'admin@ulb.ac.be'.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Password confirmation'.
	
	link := 'http://localhost:8080', url greaseString.
	bodyhtml := 'You can confirm your new password via this link: ', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:28'!
password
	^password.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:28'!
password: aPassword
	password := aPassword.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 20:18'!
save
	|msg to from subject body bodyhtml link content|
	self verifyPassword & self verifyEmail 
	ifTrue:
	[
		self waiting
		ifTrue:
		[
			to := MIMEHeaderValue forField: 'to' fromString: self email.
			from := MIMEHeaderValue forField: 'from' fromString: 'admin@ulb.ac.be'.
			content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
			subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
			link := 'http://localhost:8080', url greaseString.
			bodyhtml := 'You can confirm your email via this link: ', link.
			body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
			msg := (MailMessage new setField: 'to' to: to;
			setField: 'from' to: from;
			setField: 'subject' to: subject;
			setField: 'content' to: content;
			body: body yourself).
			(MailComposition new sendMailMessage: msg) submit.
			self activateWaiting.
		]
		ifFalse:
		[
			initialized := true.
		]
	]
	ifFalse:
	[
		email := ''.
		password := ''.
	]! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 20:15'!
setUrl: html action: anAction
	url := html actionUrl copy.
	anAction = 'initialize'
	ifTrue: 
	[
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmFirstEmail ])).
	].
	anAction = 'email'
	ifTrue: 
	[
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmail ])).
	].
	anAction = 'password'
	ifTrue: 
	[
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmPassword])).
	].! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:52'!
tempEmail: aTempEmail
	tempEmail := aTempEmail.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:52'!
tempPassword: aTempPassword
	tempPassword := aTempPassword.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:36'!
verifyEmail
	^true.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:36'!
verifyPassword
	^true.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:30'!
waiting
	^waiting.! !

!RPSS_Administrator methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:30'!
waiting: value
	waiting := value.! !

WAComponent subclass: #RPSS_Guest
	instanceVariableNames: 'password email verified tempEmail tempPassword url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:21'!
confirmEmail
	email := tempEmail.
	verified := false.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:21'!
confirmPassword 
	password := tempPassword.
	verified := false.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 18:24'!
email
	^email.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 18:25'!
email: anEmail
	email := anEmail.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 18:35'!
initialize 
	super initialize.
	email := ''.
	password := ''.
	verified := false.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 18:37'!
login
	|administrator|
	administrator := RPSS_Administrator uniqueInstance.
	(self email = administrator email) & (self password = administrator password)
	ifTrue:
	[
		verified := true.
	]
	ifFalse:
	[
	
	].
! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:06'!
modifyEmail 
	.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:41'!
modifyPassword
|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: self email.
	from := MIMEHeaderValue forField: 'from' fromString: 'admin@ulb.ac.be'.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Password confirmation'.
	
	link := 'http://localhost:8080', url greaseString.
	"bodyhtml := WAHtmlCanvas builder render: [:html | html anchor url: link; with: 'Confirm this email!!' ]."
	bodyhtml := 'You can confirm your new password via this link: ', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 18:25'!
password
	^password.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 18:25'!
password: aPassword
	password := aPassword.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:19'!
setUrl: html with: anAction
	url := html actionUrl copy.
	anAction = 'email'
	ifTrue:
	[
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmail ])).
	].

	anAction = 'password'
	ifTrue:
	[
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmPassword ])).
	].
! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:06'!
tempEmail: aTempEmail
	tempEmail := aTempEmail.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:05'!
tempPassword: aTempPassword
	tempPassword := aTempPassword.! !

!RPSS_Guest methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 18:36'!
verified
	^verified.! !

WAComponent subclass: #RPSS_Main
	instanceVariableNames: 'administrator guest userCreation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:09'!
canBeRoot 
	^true.! !

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 21:21'!
children 
	^Array with: userCreation.! !

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 21:21'!
initialize 
	super initialize.
	administrator := RPSS_Administrator uniqueInstance.
	guest := RPSS_Guest new.
	userCreation := RPSS_User new.! !

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 20:09'!
renderAdministrator: html
	html paragraph: 'Welcome administrator'.
	html paragraph: 'You can modify your email:'.
	html form: 
	[
		html textInput callback: [:value | administrator tempEmail: value].
		html break.
		html submitButton callback: [administrator setUrl: html action: 'email'. administrator modifyEmail]; value: 'Modify!!'.
	].
	html paragraph: 'You can modify your password:'.
	html form:
	[
		html textInput callback: [:value | administrator tempPassword: value].
		html break.
		html submitButton callback: [administrator setUrl: html action: 'password'. administrator modifyPassword]; value: 'Modify!!'.
	].! !

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:47'!
renderContentOn: html
	administrator isInitialized
	ifFalse: 
	[
		administrator isWaiting
		ifFalse: 
		[
			self renderInitialization: html.
		]
		ifTrue: 
		[
			self renderWaiting: html.
		]
		
	]
	ifTrue:
	[
		guest verified
		ifFalse: 
		[	
			self renderGuest: html.
			
		]
		ifTrue:
		[
			guest email = administrator email
			ifTrue: 
			[
				self renderAdministrator: html.
			]
			ifFalse: 
			[
				self renderUser: html.
			].
		]
	]! !

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 21:33'!
renderCreateUser: html
	html paragraph: 'Creating a new user'.! !

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 21:28'!
renderGuest: html
	html paragraph: 'Welcome to the main page'.
	html paragraph: 'To login, please provide the following information'.
	html 	form: 
			[
				html 	paragraph: 'Your e-mail adress:'.
				html 	textInput callback: [:value | guest email: value].
				html 	paragraph: 'Your password:'.
				html 	textInput callback: [:value | guest password: value].
				html 	break.
				html 	submitButton callback: [ guest login]; value: 'Login!!'.
			].
	html paragraph: [html anchor callback: [self renderCreateUser: html]; with: 'Create another user.'].! !

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 20:09'!
renderInitialization: html
	html div id: 'testId'; class: 'testClass'; with: 
	[
		html	paragraph: 'Welcome to A general purpose web based virtual tabletop'.
		html	paragraph: 'This version is done by group 9'.
		html 	break; break.
		html 	paragraph: 'The system is not yet initialized, please provide the following information:'.
		html 	form: 
			[
				html 	paragraph: 'Your e-mail adress:'.
				html 	textInput callback: [:value | administrator email: value].
				html 	paragraph: 'Your password:'.
				html 	textInput callback: [:value | administrator password: value].
				html 	break.
				html 	paragraph: 'Email confirmation '. 
				html 	checkbox value: true; callback: [ :value | administrator waiting: value].
				html 	break.
				html 	submitButton callback: [ administrator setUrl: html action: 'initialize'. administrator save]; value: 'Initialize!!'.
			].
	]! !

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 19:49'!
renderUser: html
	html paragraph: 'You are logged in!!'.
	html paragraph: 'You can modify your email:'.
	html form: 
	[
		html textInput callback: [:value | guest tempEmail: value].
		html break.
		html submitButton callback: [guest modifyEmail]; value: 'Modify!!'.
	].
	html paragraph: 'You can modify your password:'.
	html form:
	[
		html textInput callback: [:value | guest tempPassword: value].
		html break.
		html submitButton callback: [guest modifyPassword]; value: 'Modify!!'.
	].! !

!RPSS_Main methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/10/2011 22:37'!
renderWaiting: html
	html paragraph: 'Waiting for email confirmation'.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/11/2011 20:37'!
style 
	^ 'p{text-align:center;}
	form{text-align:center;}'! !

WAComponent subclass: #RPSS_User
	instanceVariableNames: 'email password url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_User methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 21:14'!
initialize
	super initialize.
	url := ''.
	email := ''.
	password := ''.! !

!RPSS_User methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 21:14'!
renderContentOn: html
	html paragraph: 'Creating a new user'.! !

!RPSS_User methodsFor: 'as yet unclassified' stamp: 'BogatchevOleg 10/11/2011 21:26'!
renderCreate: html
	html paragraph: 'Creating a new user!!'.! !
